<?php
/*
	Fixes bugs in diary.ru standard RSS.
	Usage:
		diary_fix_rss.php?userid=97628
*/
	header("Cache-Control: no-cache");

	$userid = $_GET['userid'];
	if ($userid=='') die("UserID required.");
	
	/* Sanitize input */
	$userid = (string)(int) $userid;
	if (strlen($userid)<4) die ("UserID must be at least 4 characters long.");

	include("curlext.php");
	$addr = "http://static.diary.ru/userdir/".$userid[0]."/".$userid[1]."/"
		.$userid[2]."/".$userid[3]."/".$userid."/rss.xml";
	$rs = curl_fetch($addr);
	if ($rs[0]<>200)
		die('Cannot fetch source RSS: '.$rcode);
	$data = $rs[1];

	/*  .     ,    ,
	    */
	$fix_date_pattern = array(
		'//i', '//i', '//i', '//i', '//i', '//i', '//i',
		'//i', '//i', '//i', '//i', '//i', '//i', '//i',
		'//i', '//i', '//i', '//i', '//i');
	$fix_date_replace = array(
		'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun',
		'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul',
		'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
	function fix_date($match) {
		global $fix_date_pattern;
		global $fix_date_replace;
		$date = preg_replace($fix_date_pattern, $fix_date_replace, $match[1]);
		$date = gmdate(DATE_RFC2822, strtotime($date));
		return "<pubDate>".$date."</pubDate>";
	}

	echo preg_replace_callback('/<pubDate>(.*?)<\/pubDate>/', fix_date, $data);
?>